{
  ZALOZNI KOD, SOUTEZNI PROGRAM JE M27.PAS
  Soutezici c. 27 Mladez
  je potreba v aktualnim adresari umistit BGI soubory a pro
  kompilaci jednotku MOUSE. Program neni mozne spustit na pocitaci,
  ktery neni osetren proti chybe programove jednotky CRT
  }

uses graph,drivers,crt,mouse,dos;

var
TDelta: longint;                { casova prodleva mezi tahy pocitace }
TopTenN: array[1..10] of string;
H,M,S,ST,LS: Word;  { Pomocne promenne pro ulozeni casu }
TopTenS: array[1..10] of longint;
Place: byte;    { Pomocna promenna oznacujici poradi }
Places: array[1..2] of byte;
T:Text;
PlayerCount: byte;
PlNames: array[1..2] of string;
Cnt,Sz: byte;
Player: byte;
Score: array[1..2] of word;
gd,gm:integer;
E: TEvent;
VLines: array[0..10,1..10] of byte;
HLines: array[0..10,1..10] of Byte;
Key: char;
PosX: longint;
PosY: longint;
Ver: boolean;
{XPos: array[1..}
HX,HY,VX,VY: longint;
PressHor: byte;
const
Colors: array[0..2] of byte = (10,12,14);

procedure ShowScoreTable; forward;  { Zobrazeni aktualniho score }
procedure DrawH(x,y,c: longint); forward;   { Vykresleni horizontalni zapalky }
procedure DrawV(x,y,c: longint); forward;   { Vykresleni vertikalni zapalky }
function IsClosed(X,Y: byte;H: boolean): boolean; forward;  { Zjisteni "uzavrenosti" ctverce }
procedure GenerateTurn;    { Generovani pocitacoveho tahu }
var
A,B: longint;
HHH: boolean;
IsTurn: boolean;
procedure MakeTurn(X,Y: byte;HH: boolean);    { Potvrzeni pocitacoveho tahu }
begin
 if not IsTurn then begin
    if HH then DrawH(a,b,Colors[Player]) else DrawV(a,b,Colors[Player]);
    if HH then HLines[a,b]:=Player else VLines[a,b]:=Player;
    IsTurn:=true;
    if IsClosed(a,b,HH) then begin
       Inc(Score[Player]);
       ShowScoreTable;
       end else if Player=1 then Player:=2 else Player:=1;
    end;
end;

function PossibleTurn(x,y: byte; ish: boolean): boolean;
begin
 if ((Ish) and (HLines[x,y]=0)) or ((not Ish) and (VLines[x,y]=0))
   then PossibleTurn:=true else PossibleTurn:=false;
end;

begin
Randomize;
IsTurn:=false;
for b:=0 to Sz-1 do
 for a:=1 to Sz do begin
   if (HLines[a,b]=0) and (HLines[a,b+1]<>0) then
     if (VLines[a,b+1]<>0) and (VLines[a-1,b+1]<>0) then MakeTurn(a,b,true);
   if (HLines[a,b]=0) and (HLines[a,b-1]<>0) then
     if (VLines[a,b]<>0) and (VLines[a-1,b]<>0) then MakeTurn(a,b,true);
     end;

for b:=1 to Sz do
  for a:=0 to Sz-1 do
   begin
    if (VLines[a,b]=0) and (VLines[a+1,b]<>0) then
     if (HLines[a+1,b]<>0) and (HLines[a+1,b-1]<>0) then
       begin
       MakeTurn(a,b,false);
       end;
    if (VLines[a,b]=0) and (VLines[a-1,b]<>0) then
     if (HLines[a,b]<>0) and (HLines[a,b-1]<>0) then
       begin
       MakeTurn(a,b,false);
       end;
    end;

if Not IsTurn   { Neni-li jina moznost, tah volen nahodne }
  then
  repeat
  A:=Random(255);
  if Odd(A) then HHH:=true else HHH:=false;
  if HHH then begin
     A:=Random(sz)+1;
     B:=Random(Sz+1);
     end else begin
         A:=Random(sz+1);
         B:=Random(Sz)+1;
         end;
     until PossibleTurn(A,B,HHH);
     MakeTurn(A,B,HHH);
end;

procedure InitField;    { Inicializace hraciho pole }
var
A,B: longint;
begin
for a:=0 to 10 do for b:=1 to 10 do begin
   VLines[a,b]:=0;
   HLines[a,b]:=0;
   end;
end;

function GetVPosX(X,Y: byte): longint;  { Zjisteni souradnic zapalek }
begin
GetVPosX:=(x)*27+21;
end;

function GetVPosY(X,Y: byte): longint;
begin
GetVPosY:=y*27+57
end;

function GetHPosX(x,y: byte): longint;
begin
GetHPosX:=x*27;
end;

function GetHPosY(x,y: byte): longint;
begin
GetHPosY:=(y+1)*27+50;
end;


procedure DrawH(x,y,c: longint);
begin
SetFillStyle(1,c);
Bar(GetHPosX(x,y),GetHPosY(x,y),GetHPosX(x,y)+18,GetHPosY(x,y)+4);
end;

procedure DrawV(x,y,c: longint);
begin
SetFillStyle(1,c);
Bar(GetVPosX(x,y),GetVPosY(x,y),GetVPosX(x,y)+4,GetVPosY(x,y)+18);
end;

function PressedOnLine(x,y: longint): boolean;          { Detekce kliku na zapalku }
var
L: longint;
POL: boolean;
begin
  POL:=false;
  L:=x mod 27;
  if (x mod 27)<18 then
     begin
     Dec(y,50);
     if (y mod 27)<4 then begin
        POL:=true;
        PressHor:=1;
        HX:=X div 27;
        HY:=y div 27-1;
{        PutPixel(Hx,Hy,12);}
         if (HX>Sz) or (HY>Sz) then POL:=false;
        end;
     end else
  begin
  Dec(x,21);
  if (x mod 27)<4 then begin
     Dec(y,57);
     if (y mod 27<18) then begin
         POL:=true;
         PressHor:=0;
         VX:=x div 27;
         VY:=y div 27;
         if (VX>Sz) or (VY>Sz) then POL:=false;
         end;
     end;
  end;
if POL then PressedOnLine:=true else PressedOnLine:=false;
end;

procedure DrawField(Size: byte);                { Vykresleni hraci plochy }
var
A,B: byte;
begin
SetFillStyle(1,10);
for b:=1 to Size+1 do
for a:=1 to Size do Bar(a*27,b*27+50,a*27+18,b*27+54);

for a:=0 to Size do
for b:=1 to size do Bar(a*27+21,b*27+57,a*27+24,b*27+73);
end;

function IsClosed(X,Y: byte;H: boolean): boolean;   { Test uzavrenosti ctverce }
begin
IsClosed:=false;
if H then begin
   if HLines[X,Y+1]<>0 then
         if (VLines[X-1,Y+1]<>0) and (VLines[X,Y+1]<>0) then
      IsClosed:=true;

   if HLines[X,Y-1]<>0 then
         if (VLines[X-1,Y]<>0) and (VLines[X,Y]<>0) then
      IsClosed:=true;
   end;
if not H then begin
   if VLines[X+1,Y]<>0 then
      if (HLines[x+1,y-1]<>0) and (HLines[x+1,y]<>0) then
      IsClosed:=true;

   if VLines[X-1,Y]<>0 then
      if (HLines[x,y-1]<>0) and (HLines[x,y]<>0) then
      IsClosed:=true;
   end;
end;
procedure ShowScoreTable;       { Zobrazeni tabulky score }
var
S:String;
begin
SetFillStyle(1,0);
Bar(400,100,640,180);
Str(Score[1]:5,s);SetColor(Colors[1]);
OutTextXY(400,100,PlNames[1]+': ');
OutTextXY(550,100,s);

Str(Score[2]:5,s);
SetColor(Colors[2]);OutTextXY(400,120,PlNames[2]+':');
OutTextXY(550,120,s);
end;

procedure ShowInfoTable;        { Zobrazeni informacni tabulky }
var
S:String;
begin
SetFillStyle(1,0);
Bar(300,200,640,480);
SetColor(Colors[Player]);
OutTextXY(300,200,'Nyni hraje: '+PlNames[Player]);
If PlayerCount=0 then begin
   Str(TDelta,s);
   OutTextXY(300,220,'Prodleva mezi tahy pocitace je '+s);
   end;
end;

function FullField(Siz: longint): boolean;      { Test, zda je vyplnena cela plocha }
var
A,b: longint;
begin
FullField:=true;
for b:=0 to Siz do
for a:=1 to Siz do if HLines[a,b]=0 then FullField:=false;

for b:=1 to Siz do
for a:=0 to Siz do if VLines[a,b]=0 then FullField:=false;
end;

begin
TDelta:=1;
Repeat
TextAttr:=14;
ClrScr;
InitField;
Writeln('                        HRA SAFETY MATCHER ( SIRKY )');
Writeln('                        ');
Writeln;
writeln;
Writeln(' Hru lze ovladat mysi nebo na klavesnici. Kurzorovymi');
writeln(' vybirejte jednotliva pole pro vlozeni zapalky, klavesou');
writeln(' tab prepinejte mezi vyberem horizontalnich a vertikalnich');
writeln(' poloh zapalek. Polozeni zapalky potvrdte klavesou enter ( misto');
writeln(' pro polozeni zapalky musi byt zelene, pokud ne, vas tah neni');
writeln(' bran v uvahu. Klavesou F1 nebo ; nechate pocitac doplnit vas tah');
writeln(' a v pripade hry bez lidskeho protivnika klavesy , a . (prip. < a >');
writeln(' nastavuji prodlevu mezi tahy pocitace. Hru ukoncite stisknutim ESC nebo ');
writeln(' vyplnenim cele hraci plochy.');
writeln;
writeln;
Writeln('Zadejte pocet hracu: (0/1/2) (0 pro pocitacem ovladaneho hrace) ');

repeat
Key:=Readkey;
until (Key>='0') and (Key<='2');
PlayerCount:=Ord(Key)-Ord('0');

for sz:=ord(Key)-ord('0')+1 to 2 do PlNames[sz]:='Computer';
for sz:=1 to ord(Key)-ord('0') do begin
    write('Zadejte jmeno ',sz,'. hrace: ');
    Readln(PlNames[sz]);
    end;

if (PlNames[1]=PlNames[2]) then PlNames[2]:=PlNames[2]+' 2';
Write('Zadejte velikost hraciho pole:');
{$I-}
repeat
Readln(Sz);
until (IoResult=0) and (Sz>1) and (Sz<11);

for Posx:=1 to 2 do Score[PosX]:=0;
initgraph(gd,gm,'');
InitMouse;
HideMouse;

DrawField(Sz);
Player:=1;
PutPixel(GetVPosX(1,1),GetVPosY(1,1),14);
PutPixel(GetHPosX(1,1),GetHPosY(1,1),14);
ShowMouse;
Ver:=false;

PosX:=1;
PosY:=0;

ShowScoreTable;
ShowMouse;
ShowInfoTable;
repeat
GetTime(H,M,S,ST);

if (S<>LS) then begin           { Zjisteni, zda muze pocitac generovat tah v demu }
   if ((S<LS) and (S+60-LS>=TDelta)) or ((S>LS) and (S-LS>=TDelta)) then
   if PlayerCount=0 then begin
      GenerateTurn;
      ShowInfoTable;
      LS:=S;
      end;
   end;

if (PlayerCount=1) and (Player=2) then begin
   GenerateTurn;
   ShowInfoTable;
   end;
if Pressed(0) then     { Pokud se klikne,... }
   begin
   HideMouse;
   if PressedOnLine(mx,my) and (PlayerCount>=1) then begin   { ...test, zda se kliklo na sirku a zda hra neni demo }
      if PressHor=0 then begin
         Ver:=true;
         PosX:=VX;
         PosY:=VY;
         if VLines[PosX,PosY]=0 then begin
         VLines[PosX,PosY]:=Player;
         SetFillStyle(1,Colors[VLines[PosX,PosY]]);
         Bar(GetVPosX(PosX,PosY),GetVPosY(PosX,PosY),GetVPosX(PosX,PosY)+4,GetVPosY(PosX,PosY)+18);
         if IsClosed(PosX,PosY,NOT Ver) then begin
            Inc(Score[Player]);
            ShowScoreTable;
            end else if Player=1 then Player:=2 else Player:=1;
         PosX:=0;
         ShowInfoTable;
         PosY:=1;
         end;
         end
         else begin
              PosX:=HX;
              PosY:=HY;
              Ver:=false;
              if HLines[PosX,PosY]=0 then begin
              HLines[PosX,PosY]:=Player;
              SetFillStyle(1,Colors[HLines[PosX,PosY]]);
              Bar(GetHPosX(PosX,PosY),GetHPosY(PosX,PosY),GetHPosX(PosX,PosY)+18,GetHPosY(PosX,PosY)+4);
              if IsClosed(PosX,PosY,NOT Ver) then begin
                  Inc(Score[Player]);
                  ShowScoreTable;
                  end else if Player=1 then Player:=2 else Player:=1;
              PosX:=1;
              PosY:=0;
              ShowInfoTable;
              Ver:=false;
              end;
              end;
      end;
   ShowMouse;
   end;
if keypressed then begin  { Obsluha klavesnice }
   Key:=Readkey;
   if Key=#0 then Key:=Readkey;
   if Key=';' then begin
      GenerateTurn;
      ShowInfoTable;
      end;

   if (Key=#13) and (PlayerCount>0) then begin
      if not Ver then begin
         if HLines[PosX,PosY]=0 then begin
         HLines[PosX,PosY]:=Player;
         SetFillStyle(1,Colors[HLines[PosX,PosY]]);
         Bar(GetHPosX(PosX,PosY),GetHPosY(PosX,PosY),GetHPosX(PosX,PosY)+18,GetHPosY(PosX,PosY)+4);
         if IsClosed(PosX,PosY,NOT Ver) then begin
             Inc(Score[Player]);
             ShowScoreTable;
             end else if Player=1 then Player:=2 else Player:=1;
         PosX:=1;
         PosY:=0;
         Ver:=false;
         end;
         end else
         begin
         if VLines[PosX,PosY]=0 then begin
         VLines[PosX,PosY]:=Player;
         SetFillStyle(1,Colors[VLines[PosX,PosY]]);
         Bar(GetVPosX(PosX,PosY),GetVPosY(PosX,PosY),GetVPosX(PosX,PosY)+4,GetVPosY(PosX,PosY)+18);
         if IsClosed(PosX,PosY,NOT Ver) then begin
            Inc(Score[Player]);
            ShowScoreTable;
            end else if Player=1 then Player:=2 else Player:=1;
         PosX:=0;
         PosY:=1;
         end;
         end;
      end;

   if Key=#9 then begin
      if not Ver then begin
         SetFillStyle(1,Colors[HLines[PosX,PosY]]);
         Bar(GetHPosX(PosX,PosY),GetHPosY(PosX,PosY),GetHPosX(PosX,PosY)+18,GetHPosY(PosX,PosY)+4);
         PosX:=0;
         PosY:=1;
         Ver:=true;
         end else
         begin
         SetFillStyle(1,Colors[HLines[PosX,PosY]]);
         Bar(GetVPosX(PosX,PosY),GetVPosY(PosX,PosY),GetVPosX(PosX,PosY)+4,GetVPosY(PosX,PosY)+18);
         PosX:=1;
         PosY:=0;
         Ver:=False;
         end;
      end;

   if Key='P' then begin
      if not Ver then begin
         SetFillStyle(1,Colors[HLines[PosX,PosY]]);
         Bar(GetHPosX(PosX,PosY),GetHPosY(PosX,PosY),GetHPosX(PosX,PosY)+18,GetHPosY(PosX,PosY)+4);
         if PosY<Sz then Inc(PosY);
         SetFillStyle(1,15);
         Bar(GetHPosX(PosX,PosY),GetHPosY(PosX,PosY),GetHPosX(PosX,PosY)+18,GetHPosY(PosX,PosY)+4);
         end;
      if Ver then begin
         SetFillStyle(1,Colors[VLines[PosX,PosY]]);
         Bar(GetVPosX(PosX,PosY),GetVPosY(PosX,PosY),GetVPosX(PosX,PosY)+4,GetVPosY(PosX,PosY)+18);
         if PosY<Sz then Inc(PosY);
         SetFillStyle(1,15);
         Bar(GetVPosX(PosX,PosY),GetVPosY(PosX,PosY),GetVPosX(PosX,PosY)+4,GetVPosY(PosX,PosY)+18);
         end;
      end;
   if Key='>' then if TDelta<10 then begin inc(TDelta); ShowInfoTable; end;
   if Key='<' then if TDelta>1 then begin dec(TDelta); ShowInfoTable; end;
   if Key='.' then if TDelta<10 then begin inc(TDelta); ShowInfoTable; end;
   if Key=',' then if TDelta>1 then begin dec(TDelta); ShowInfoTable; end;

   if Key='M' then begin
      if not Ver then begin
         SetFillStyle(1,Colors[HLines[PosX,PosY]]);
         Bar(GetHPosX(PosX,PosY),GetHPosY(PosX,PosY),GetHPosX(PosX,PosY)+18,GetHPosY(PosX,PosY)+4);
         if PosX<Sz then Inc(PosX);
         SetFillStyle(1,15);
         Bar(GetHPosX(PosX,PosY),GetHPosY(PosX,PosY),GetHPosX(PosX,PosY)+18,GetHPosY(PosX,PosY)+4);
         end;
      if Ver then begin
         SetFillStyle(1,Colors[VLines[PosX,PosY]]);
         Bar(GetVPosX(PosX,PosY),GetVPosY(PosX,PosY),GetVPosX(PosX,PosY)+4,GetVPosY(PosX,PosY)+18);
         if PosX<Sz then Inc(PosX);
         SetFillStyle(1,15);
         Bar(GetVPosX(PosX,PosY),GetVPosY(PosX,PosY),GetVPosX(PosX,PosY)+4,GetVPosY(PosX,PosY)+18);
         end;
      end;

   if Key='H' then begin
      if not Ver then begin
         SetFillStyle(1,Colors[HLines[PosX,PosY]]);
         Bar(GetHPosX(PosX,PosY),GetHPosY(PosX,PosY),GetHPosX(PosX,PosY)+18,GetHPosY(PosX,PosY)+4);
         if PosY>0 then Dec(PosY);
         SetFillStyle(1,15);
         Bar(GetHPosX(PosX,PosY),GetHPosY(PosX,PosY),GetHPosX(PosX,PosY)+18,GetHPosY(PosX,PosY)+4);
         end;
      if Ver then begin
         SetFillStyle(1,Colors[VLines[PosX,PosY]]);
         Bar(GetVPosX(PosX,PosY),GetVPosY(PosX,PosY),GetVPosX(PosX,PosY)+4,GetVPosY(PosX,PosY)+18);
         if PosY>1 then Dec(PosY);
         SetFillStyle(1,15);
         Bar(GetVPosX(PosX,PosY),GetVPosY(PosX,PosY),GetVPosX(PosX,PosY)+4,GetVPosY(PosX,PosY)+18);
         end;
      end;

   if Key='K' then begin
      if not Ver then begin
         SetFillStyle(1,Colors[HLines[PosX,PosY]]);
         Bar(GetHPosX(PosX,PosY),GetHPosY(PosX,PosY),GetHPosX(PosX,PosY)+18,GetHPosY(PosX,PosY)+4);
         if PosX>1 then Dec(PosX);
         SetFillStyle(1,15);
         Bar(GetHPosX(PosX,PosY),GetHPosY(PosX,PosY),GetHPosX(PosX,PosY)+18,GetHPosY(PosX,PosY)+4);
         end;
      if Ver then begin
         SetFillStyle(1,Colors[VLines[PosX,PosY]]);
         Bar(GetVPosX(PosX,PosY),GetVPosY(PosX,PosY),GetVPosX(PosX,PosY)+4,GetVPosY(PosX,PosY)+18);
         if PosX>0 then Dec(PosX);
         SetFillStyle(1,15);
         Bar(GetVPosX(PosX,PosY),GetVPosY(PosX,PosY),GetVPosX(PosX,PosY)+4,GetVPosY(PosX,PosY)+18);
         end;
      end;

   end;
until (Key=#27) or FullField(Sz);
CloseGraph;
assign(t,'scores.dat');
{$I-}
reset(t);
if IoResult = 0 then begin
  for Sz:=1 to 10 do begin
      Readln(t,TopTenN[Sz]);
      Readln(T,TopTenS[Sz]);
      end;
  for Cnt:=1 to 2 do begin
    Place:=1;
    Places[Cnt]:=255;
    while TopTenS[Place]>Score[Cnt] do Inc(Place);
    if Place<=10 then
       begin
            for sz:=9 downto Place do begin
                TopTenN[sz+1]:=TopTenN[Sz];
                TopTenS[sz+1]:=TopTenS[sz];
                end;
            TopTenN[Place]:=PlNames[Cnt];
            TopTenS[Place]:=Score[Cnt];
            end;
  end;      { Zobrazeni TOP TEN SCORE }
  writeln('                              TOP TEN SCORES'); writeln; writeln;
  for Cnt:=1 to 10 do
    begin
       TextAttr:=15;
       for Sz:=1 to 2 do
       if (TopTenN[Cnt]=PlNames[Sz]) and (TopTenS[Cnt]=Score[Sz]) and (Places[Sz]=255) then
          begin
          Places[Sz]:=Cnt;
          TextAttr:=Colors[Sz];
          end;
       gotoxy(3,Cnt+4);
       Writeln(Cnt:2,'.',TopTenN[Cnt]);
       GotoXY(65,Cnt+4);
       Writeln(TopTenS[Cnt]);
       end;
  Writeln; writeln;
  for Sz:=1 to 2 do begin
    TextColor(Colors[Sz]);
    if Places[Sz]=255 then writeln(PlNames[Sz],' se nedostava do tabulky TOP-TEN')
         else Writeln(PlNames[Sz],' je na ',Places[Sz],'. miste');
    end;
  close(t);
  end;
  rewrite(t);
  for cnt:=1 to 10 do begin
      Writeln(t,TopTenN[Cnt]);
      Writeln(T,TopTenS[Cnt]);
      end;
  close(t);
Writeln; writeln; writeln; textattr:=15;
Write('Prejete si hrat znovu ? (A/N)');
repeat
Key:=Readkey;
until (UpCase(Key)='A') or (Upcase(Key)='N');
until UpCase(Key)='N';

end.